import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useState as n, useLayoutEffect as o, useMemo as r, useCallback as i, useEffect as s, useRef as l } from "react";

import { VirtualScrollerEvent as c, VirtualScroller as f } from "@af-utils/virtual-core";

import { useSyncExternalStore as u } from "use-sync-external-store/shim";

function a(t, e) {
    const n = [];
    for (let o = t.from, r = t.to; r > o; o++) n.push(e(o));
    return n;
}

function h(t, e) {
    const n = [];
    for (let o = t.from, r = t.to, i = t.getOffset(o); r > o; i += t.getSize(o), o++) n.push(e(o, i));
    return n;
}

const d = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    zIndex: -1
}, m = {
    ...d,
    height: "100%"
}, p = {
    ...d,
    width: "100%"
}, S = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, g = {
    ...S,
    display: "flex",
    height: "100%"
}, v = {
    ...S,
    display: "block",
    width: "100%"
};

function y(t) {
    const [e, r] = n(null), [i, s] = n(null);
    return o((() => {
        if (t && e && i) {
            const n = () => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }, o = () => {
                const e = t.getOffset(t.from), n = t.getOffset(t.to);
                i.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, i.style[t.horizontal ? "width" : "height"] = n - e + "px";
            }, r = t.on(n, [ c.SCROLL_SIZE ]), s = t.on(o, [ c.RANGE, c.SIZES ]);
            return Object.assign(e.style, t.horizontal ? m : p), Object.assign(i.style, t.horizontal ? g : v), 
            n(), o(), () => {
                r(), s();
            };
        }
    }), [ t, e, i ]), [ r, s ];
}

function x(t) {
    switch (t) {
      case c.RANGE:
        return this.to ** 2 + this.from;

      case c.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

function z(t, e) {
    const [n, o] = r((() => [ n => t.on(n, e), () => e.map(x, t).join() ]), [ t, e ]);
    u(n, o, o);
}

function w(t) {
    return z(t.model, t.events), t.children();
}

function E(n) {
    const {model: o, children: r, itemData: s, component: l = "div", header: f = null, footer: u = null, getKey: h = (t => t), tabIndex: d = -1, style: m, ...p} = n, [S, g] = y(o);
    return t(l, {
        ...p,
        style: {
            overflow: "auto",
            contain: "strict",
            ...m
        },
        ref: i((t => o.setScroller(t)), [ o ]),
        tabIndex: d,
        children: [ f, e("div", {
            ref: S,
            children: e("div", {
                ref: g,
                children: e(w, {
                    model: o,
                    events: [ c.RANGE ],
                    children: () => a(o, (t => e(r, {
                        model: o,
                        i: t,
                        data: s
                    }, h(t, s))))
                })
            })
        }), u ]
    });
}

const I = process.env.__IS_SERVER__ ? s : o;

function O(t, e) {
    I((() => (t.setScroller(e), () => t.setScroller(null))), [ t, e ]);
}

function R(t, e, n) {
    s((() => {
        if (n) return n(), t.on(n, e);
    }), [ t, n, e ]);
}

function _(t) {
    return l().current ||= new f(t);
}

function b(t) {
    const e = _(t);
    return I((() => e.set(t))), e;
}

export { E as List, w as Subscription, a as mapVisibleRange, h as mapVisibleRangeWithOffset, z as useComponentSubscription, O as useScroller, R as useSubscription, y as useSyncedStyles, b as useVirtual, _ as useVirtualModel };
//# sourceMappingURL=index.js.map
